# encoding: utf-8
module EasySolr
  module Translate

    @nn_mysql_primary_key = nil
    @nn_solr_primary_key  = nil
    @pri_key              = false

    ##
    # ==== Description
    #
    # 获取用户配置信息中MySQL表主键
    #
    def mysql_pri_key
      @nn_mysql_primary_key
    end

    ##
    # ==== Description
    #
    # 获取用户配置信息中Solr 主键
    #
    def solr_pri_key
      @nn_solr_primary_key
    end

    alias solr_primary_key solr_pri_key
    alias mysql_primary_key mysql_pri_key

    ##
    # ==== Description
    #
    # 用户 MySQL 和 Solr 对应关系中主键是否设置
    #
    def pri_key_present?
      self.break_down
      @pri_key
    end

    ##
    # ==== Description
    #
    # 插接配置并
    #
    # ==== Attention
    #
    # 主键配置以第一次配置为主
    # 设置
    #  @nn_solr_primary_key solr主键
    #  @nn_mysql_primary_key mysql主键
    #  @pri_key              主键是否存在
    #
    def break_down(links)
      links.each_pair do |_key, _value|
        if _value[:primary]
          @nn_solr_primary_key  = _value[:solr_name]
          @nn_mysql_primary_key = _key
          @pri_key              = true

          break
        end
      end
    end

  end
end

